%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%STUFF THAT NEEDS SETTING%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath 'SPM_jobs'

%list of subject folder names
subjects = {'19840420CARU'
            '19910121HAHN'
            '19910517CRGR'
            '19940913AGBR'
            '19941213KTGL'
            '19950821CRHD'
            '19960110VCHR'
            '19970105HMBN'
            '19970108KRWE'
            '19970217AUAE'
            '19970315RNBD'
            '19970325JAMA'
            '19970421DAPN'
            '19970617BCTO'
            '19970702HAAS'
            '19970711CAWK'
            '19970911JLCA'
            '19971006LRJY'
            '19971102JAPR'
            '19971127SMMR'
            '19980103AGCA'
            '19980425NCHD'
            '19981201SRNG'
            '19990223FRFR'
};

subjects = subjects'; %horizontal vector

%where the data is
basepath = '/Users/m.belyk/Documents/MATLAB/Resting_Stella/';

%%%SOME SETTINGS%%%
%some settings
spm('defaults','fmri');
spm_jobman('initcfg');

%load spm template jobs
load('segment.mat')
load('normalize.mat')

%%%Image preprocessing %%%

tic %a time thingy
for s = subjects %loop through subjects
    %steps to do once per subject go here
    
    disp('%%%%%%%%%%%%%%%%%%%%%%%%') 
    disp(strcat("Start Subject: ", s))
    disp('%%%%%%%%%%%%%%%%%%%%%%%%') 
    
    %build path to ANAT folder
    anatpath = fullfile(basepath, s,'anat');

    %%%%%%%%%%%%%  
    %%%Segment%%%
    %%%%%%%%%%%%%
    %setup T1 segmentation job
    segment{1}.spm.spatial.preproc.channel.vols = fullfile(anatpath,'anat.nii');%T1
    
    %execute T1 segmentation job
    spm_jobman('run',segment)
    disp(strcat("Done Segmenting T1: ", s)) 
    
    %%%%%%%%%%%%%%%%%%
    %%%Normalize_T1%%%
    %%%%%%%%%%%%%%%%%%
    %setup normalization job
    normalize{1}.spm.spatial.normalise.write.subj.def = fullfile(anatpath,'y_anat.nii');%deformation field
    normalize{1}.spm.spatial.normalise.write.subj.resample = fullfile(anatpath,'anat.nii');
    
    %execute normalization job
    spm_jobman('run',normalize)
    load('normalize.mat')%reset before ahead of bold normalization
    disp(strcat("Done Normalizing T1: ", s))
    
    
    %%%%%%%%%%%%%  
    %%%Segment%%% 
    %%%%%%%%%%%%%
    %now segment normalized t1 so we can get mni greymatter
    
    %setup T1 segmentation job
    segment{1}.spm.spatial.preproc.channel.vols = fullfile(anatpath,'wanat.nii');%T1
    
    %execute T1 segmentation job
    spm_jobman('run',segment)
    disp(strcat("Done Segmenting Normalized T1: ", s)) 
 
    
end
